﻿//-----------------------------------------------------------------------
// <copyright file="IWizardPage.cs" company="Sondre Bjellås">
// This software is licensed as Microsoft Public License (Ms-PL).
// </copyright>
//-----------------------------------------------------------------------

using System.Drawing;

namespace FlickrDownloadr
{
    /// <summary>
    /// Interface that defines properties for the wizard pages.
    /// </summary>
    public interface IWizardPage
    {
        /// <summary>
        /// Delegate to handle the "Next" user action.
        /// </summary>
        event NextDelegate Next;

        /// <summary>
        /// Gets the title of the wizard page.
        /// </summary>
        string Title { get; }

        /// <summary>
        /// Gets the description of the wizard page.
        /// </summary>
        string Description { get; }

        /// <summary>
        /// Gets the icon for the wizard page.
        /// </summary>
        Bitmap Icon { get; }

        /// <summary>
        /// Used to refresh the content of the wizard page if needed.
        /// </summary>
        /// <returns></returns>
        void ReloadPage();
    }
}
