﻿//-----------------------------------------------------------------------
// <copyright file="Program.cs" company="Sondre Bjellås">
// This software is licensed as Microsoft Public License (Ms-PL).
// </copyright>
//-----------------------------------------------------------------------

using System;
using System.Windows.Forms;

namespace FlickrDownloadr
{
    /// <summary>
    /// Class that holds the pain entry point.
    /// </summary>
  public static class Program
  {

    #if DEBUG
    public static bool Debug = false;
    #else
    public static bool Debug = false;
    #endif

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    public static void Main(string[] args)
    {
        if (args.Length > 0)
        {
            if (args[0] == "debug")
            {
                Debug = true;
            }
        }

      Application.EnableVisualStyles();

      Application.SetCompatibleTextRenderingDefault(false);

      Application.Run(new FormFlickr());
    }

    public static bool IsWindows7()
    {
        return (Environment.OSVersion.Version.Major >= 6 && Environment.OSVersion.Version.Build >= 7600);
    }
  }
}