﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FlickrDownloadr.Controls
{
    /// <summary>
    /// Provides a circular progress bar
    /// </summary>
    public partial class CircularProgressBar : UserControl
    {
        static CircularProgressBar()
        {
            //Use a default Animation Framerate of 30, which uses less CPU time
            //than the standard 50 which you get out of the box
            Timeline.DesiredFrameRateProperty.OverrideMetadata(
                typeof(Timeline),
                    new FrameworkPropertyMetadata { DefaultValue = 30 });
        }

        public CircularProgressBar()
        {
            InitializeComponent();
        }

        protected override void OnPropertyChanged(DependencyPropertyChangedEventArgs e)
        {
            // Ensure that the storyboard is stopped when the visibility is hidden.
            if (e.Property.Name == "Visibility")
            {
                if ((Visibility)e.NewValue == Visibility.Visible)
                {
                    storyBoard.Begin();
                }
                else
                {
                    storyBoard.Stop();
                }
            }

            base.OnPropertyChanged(e);
        }
    }
}
