﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using FlickrNet;

namespace FlickrDownloadr
{
    public static class Watermark
    {
        private static Dictionary<LicenseType, List<Image>> _watermarks;

        public static Dictionary<LicenseType, List<Image>> Watermarks
        {
            get
            {
                if (_watermarks == null)
                {
                    LoadWatermarks();
                }
                
                return _watermarks;
            }
        }

        private static void LoadWatermarks()
        {
            _watermarks = new Dictionary<LicenseType, List<Image>>();

            _watermarks.Add(LicenseType.AllRightsReserved, new List<Image>() { Properties.Resources.cr_small });
            _watermarks.Add(LicenseType.AttributionCC, new List<Image>() { Properties.Resources.by });
            _watermarks.Add(LicenseType.AttributionShareAlikeCC, new List<Image>() { Properties.Resources.by, Properties.Resources.sa });
            _watermarks.Add(LicenseType.AttributionNoDerivativesCC, new List<Image>() { Properties.Resources.by, Properties.Resources.nd });
            _watermarks.Add(LicenseType.AttributionNoncommercialCC, new List<Image>() { Properties.Resources.by, Properties.Resources.nc });
            _watermarks.Add(LicenseType.AttributionNoncommercialShareAlikeCC, new List<Image>() { Properties.Resources.by, Properties.Resources.nc, Properties.Resources.sa });
            _watermarks.Add(LicenseType.AttributionNoncommercialNoDerivativesCC, new List<Image>() { Properties.Resources.by, Properties.Resources.nc, Properties.Resources.nd });
        }
    }
}
